=== debian/changelog ===
pam-wrapper (1.1.8-1) unstable; urgency=medium

  * New upstream version 1.1.8
  * Standards-Version: 4.7.2.
  * Bump debian/* copyright years.
  * Run wrap-and-sort -satbk.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 17 Aug 2025 13:05:51 +0200
